package com.engine.jucailinkq.attendance.component.page.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.jucailinkq.attendance.component.calendarscheduling.service.WorkRulesService;
import com.engine.jucailinkq.attendance.component.calendarscheduling.service.impl.WorkRulesServiceImpl;
import com.engine.jucailinkq.attendance.component.page.service.PersonPageService;
import com.engine.jucailinkq.attendance.component.page.service.impl.PersonPageServiceImpl;
import com.engine.jucailinkq.common.util.ApiReturnTools;
import com.engine.jucailinkq.common.util.ResponseResult;
import lombok.extern.slf4j.Slf4j;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

@Slf4j
public class PersonPageAction {

    private PersonPageService getPersonPageService(User user) {
        return ServiceUtil.getService(PersonPageServiceImpl.class,user);
    }

    /**
     * 出勤结果更改时插入排班结果
     * @return
     */
    @POST
    @Path("/getPersonPageData")
    @Produces({"text/plain"})
    public String saveScheduleResult(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            Map<String,Object> paramMap = ParamUtil.request2Map(request);
            User user = HrmUserVarify.getUser(request, response);
            Map<String,Object> dataMap = getPersonPageService(user).getPersonPageService(paramMap);
            return ApiReturnTools.success(dataMap);
        }catch (Exception e){
            log.error("execute fail,catch error: [{}]",e);
            return ApiReturnTools.error("500","saveApplicableOrganization error");
        }
    }

    @GET
    @Path("/list")
    @Produces(MediaType.APPLICATION_JSON)
    public String getWorkRulesList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> paramMap = ParamUtil.request2Map(request);

        return new ResponseResult<Map<String,Object>, Map<String, Object>>(user).run(getPersonPageService(user) :: getWorkInfoList,paramMap);
    }
}
