package com.engine.jucailinkq.common.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailinkq.common.util.CommonUtil;
import com.engine.jucailinkq.common.util.DateUtil;
import com.engine.jucailinkq.common.util.DbTools;
import com.engine.jucailinkq.common.util.ExtensionClassHolder;
import com.google.common.collect.Maps;
import weaver.general.Util;

import java.util.List;
import java.util.Map;

public class CleanHaveLeaveUserDataCmd extends AbstractCommonCommand<Map<String, Object>> {

    public CleanHaveLeaveUserDataCmd(Map<String, Object> params) {
        this.params = params;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String startDate = Util.null2String(params.get("startDate"));
        String endDate = Util.null2String(params.get("endDate"));
        String userIds = Util.null2String(params.get("userIds"));

        Map<String, Object> resultMap = Maps.newHashMap();

        CommonUtil.initExtensionClassHolder();
        //入职离职当天是否需要进行考勤分析。0：入职离职当天均分析、1：入职离职当天不分析
        String leaveAndEntry = Util.null2String(ExtensionClassHolder.getGlobalSetMap().get("leaveAndEntry"));


        if (userIds.equals("")) {
            String queryDepartEmployeeSql = "select resourceid ,changedate,type_n  from HRMSTATUSHISTORY ";
            //获取离职日期
            List<Map<String, Object>> departEmployeeList = DbTools.getSqlToList(queryDepartEmployeeSql);
            Map<String, Object> departEmployeeMap = CommonUtil.getDepartEmployeeMap(departEmployeeList);
            String queryUserSql = "select id,companystartdate,seclevel,departmentid,subcompanyid1 from hrmresource";
            List<Map<String, Object>> userList = DbTools.getSqlToList(queryUserSql);
            String updateSql = "delete from uf_jcl_kq_cqjg where ygid = ? and rq >= ? and rq <= ?";
            for (Map<String, Object> userMap : userList) {
                String companystartdate = Util.null2String(userMap.get("companystartdate"));
                String terminationDate = Util.null2String(departEmployeeMap.get(userMap.get("id")));
                String user = Util.null2String(userMap.get("id"));

                if (!"".equals(companystartdate) && DateUtil.getTime(companystartdate).compareTo(DateUtil.getTime(endDate)) <= 0 &&
                        DateUtil.getTime(companystartdate).compareTo(DateUtil.getTime(startDate)) >= 0) {
                    if ("1".equals(leaveAndEntry)) {
                        DbTools.update(updateSql, user, startDate, companystartdate);
                    } else {
                        String beforeCompanystartdateDay = DateUtil.beforeDay(companystartdate, 1);
                        if (DateUtil.getTime(beforeCompanystartdateDay).compareTo(DateUtil.getTime(startDate)) >= 0) {
                            DbTools.update(updateSql, user, startDate, beforeCompanystartdateDay);
                        }
                    }
                }
                if (!"".equals(terminationDate) && DateUtil.getTime(terminationDate).compareTo(DateUtil.getTime(endDate)) <= 0 &&
                        DateUtil.getTime(terminationDate).compareTo(DateUtil.getTime(startDate)) >= 0) {
                    if ("1".equals(leaveAndEntry)) {
                        DbTools.update(updateSql, user, terminationDate, endDate);
                    } else {
                        String AfterDay = DateUtil.AfterDay(terminationDate, 1);
                        if (DateUtil.getTime(AfterDay).compareTo(DateUtil.getTime(endDate)) <= 0) {
                            DbTools.update(updateSql, user, AfterDay, endDate);
                        }
                    }
                }

            }
        } else {
            String queryDepartEmployeeSql = "select resourceid ,changedate,type_n  from HRMSTATUSHISTORY  where resourceid in (" + userIds + ")";
            //获取离职日期
            List<Map<String, Object>> departEmployeeList = DbTools.getSqlToList(queryDepartEmployeeSql);
            Map<String, Object> departEmployeeMap = CommonUtil.getDepartEmployeeMap(departEmployeeList);
            String queryUserSql = "select id,companystartdate,seclevel,departmentid,subcompanyid1 from hrmresource where id in (" + userIds + ")";
            List<Map<String, Object>> userList = DbTools.getSqlToList(queryUserSql);
            String updateSql = "delete from uf_jcl_kq_cqjg where ygid = ? and rq >= ? and rq <= ?";
            for (Map<String, Object> userMap : userList) {
                String companystartdate = Util.null2String(userMap.get("companystartdate"));
                String terminationDate = Util.null2String(departEmployeeMap.get(userMap.get("id")));
                String user = Util.null2String(userMap.get("id"));

                if (!"".equals(companystartdate) && DateUtil.getTime(companystartdate).compareTo(DateUtil.getTime(endDate)) <= 0 &&
                        DateUtil.getTime(companystartdate).compareTo(DateUtil.getTime(startDate)) >= 0) {
                    if ("1".equals(leaveAndEntry)) {
                        DbTools.update(updateSql, user, startDate, companystartdate);
                    } else {
                        String beforeCompanystartdateDay = DateUtil.beforeDay(companystartdate, 1);
                        if (DateUtil.getTime(beforeCompanystartdateDay).compareTo(DateUtil.getTime(startDate)) >= 0) {
                            DbTools.update(updateSql, user, startDate, beforeCompanystartdateDay);
                        }
                    }
                }else if (!"".equals(companystartdate) && DateUtil.getTime(companystartdate).compareTo(DateUtil.getTime(endDate))>0){
                    DbTools.update(updateSql,user,startDate,endDate);
                }
                if (!"".equals(terminationDate) && DateUtil.getTime(terminationDate).compareTo(DateUtil.getTime(endDate)) <= 0 &&
                        DateUtil.getTime(terminationDate).compareTo(DateUtil.getTime(startDate)) >= 0) {
                    if ("1".equals(leaveAndEntry)) {
                        DbTools.update(updateSql, user, terminationDate, endDate);
                    } else {
                        String AfterDay = DateUtil.AfterDay(terminationDate, 1);
                        if (DateUtil.getTime(AfterDay).compareTo(DateUtil.getTime(endDate)) <= 0) {
                            DbTools.update(updateSql, user, AfterDay, endDate);
                        }
                    }
                }else if (!"".equals(terminationDate) && DateUtil.getTime(terminationDate).compareTo(DateUtil.getTime(startDate))<0 ){
                    DbTools.update(updateSql,user,startDate,endDate);
                }

            }

        }


        resultMap.put("code", "200");
        return resultMap;
    }
}
